import os
import sys
import importlib.util
import pathlib

ROOT = pathlib.Path(__file__).parent.parent.absolute()

print("\nSearching for tests at the path: "+ str(ROOT))

count = 0
resultCodeList = []
for (dirname, dirs, files) in os.walk(ROOT):
    #print("\n In dir: "+ str(dirname))

    #I assume all the tests are placed in a folder named "tests"
    if ("\\tests" in str(dirname)) and not("\\tests\\" in str(dirname)):
        try:
            os.chdir(os.path.normpath(dirname))
            exit_val = os.system("py -m unittest discover")
            resultCodeList.append(exit_val) #once per folder  i.e if 3 tests are in a folder and crash, there will be just one exit val
        except Exception as e:
            print(e)
            continue
        """
        for f in files:
            
            #print("\n Get Current Directory "+ os.getcwd())
            count += 1
            print("\n"+ str(count) +" Executing:      "+ str(os.path.normpath(dirname+"\\"+f)))
            os.system("py "+ f)
        """

firstError = -1
i = 0
while i < len(resultCodeList):
    if resultCodeList[i] != 0:
        print("\nA test failed with code: "+ resultCodeList[i])
        if (firstError < 0):
            firstError = i
    i += 1

if(firstError<0): #no errors found
    sys.exit(0)
else:
    sys.exit(resultCodeList[firstError]) #return the error code of the first error